      integer*4 function get_number_levels(Hv_csr,discard_obs,NPRF,n_lvls)
! This function returns  the number of model levels used in vertical interpolation
! to pressure levels.  This number is needed to determine the number of non-zero
! element in a matrix containing the result of the multiplication of the averaging kernel
! and the matrix containing the result of Ht*Hv*Hh.

  use MATRIX_CSR_STRUCTURE

  implicit none

! input variables:
      type(CSR_FORMAT),intent(in)               :: Hv_csr  !vertical operator
      integer*4,intent(in)                      :: NPRF    !number of obs. profiles
!maximum number of obs vertical levels:
      integer*4,intent(in)                      :: n_lvls  
      logical, dimension(NPRF),intent(in)       :: discard_obs


      integer*4                              :: itmp_save,itmp,lvls_out,i,np
      real*4                                 :: lvls_interp


      lvls_out=0
      do np=1,NPRF
        if (.not.discard_obs(np)) then
          itmp_save=0
          lvls_interp=0.
          do i=1,n_lvls
            itmp=abs(Hv_csr%j(Hv_csr%i(i,np),np))
            if (abs(itmp-itmp_save).gt.1) then
              lvls_interp=lvls_interp+1
              itmp_save=itmp
            else if (abs(itmp-itmp_save).eq.1) then
              lvls_interp=lvls_interp+0.5
              itmp_save=itmp
            end if
          end do
          lvls_out=max(lvls_out,nint(lvls_interp))
        end if
      end do
      get_number_levels=lvls_out
      return
      end function get_number_levels

