     subroutine multiply_observ_operator(Hres_csr,Mod_data,ntime,   &
                                         discard_obs,NPRF,nlvs_out, &
                                         traceur_out)

  use floats
  use MODEL_STRUCTURE
  use MATRIX_CSR_STRUCTURE
  use matrix_manipulations
!
  IMPLICIT none
!
  type(MODEL_DATA)                       :: Mod_data
  type(CSR_FORMAT)                       :: Hres_csr
  INTEGER*4                              :: ntime
  INTEGER*4                              :: NPRF
  INTEGER*4                              :: nlvs_out
  logical,dimension(NPRF)                :: discard_obs
!
  real(std),dimension(nlvs_out,NPRF)     :: traceur_out

! local
  real(std),pointer,dimension(:)         :: vector
  integer                                :: np
  real(std),pointer,dimension(:,:)       :: traceur_tmp

  integer*4                              :: ALLOC_ERR


     allocate(vector(Mod_data%nlat*Mod_data%nlon*Mod_data%nlev*ntime))
     call create_state_vector(Mod_data%nlat,Mod_data%nlon,Mod_data%nlev,  &
                              ntime,Mod_data%traceur,vector)

!    compute the product H* traceur


     allocate(traceur_tmp(Hres_csr%nrow,NPRF),STAT = ALLOC_ERR)
     call check_allocate(ALLOC_ERR,"multiply_matrix_csr_vector")
     call multiply_matrix_csr_vector(Hres_csr,vector, &
                                     Hres_csr%nrow,NPRF,  &
                                     traceur_tmp)
     deallocate(vector)

     traceur_out=traceur_tmp
     deallocate(traceur_tmp)

     do np=1,NPRF
       if (discard_obs(np)) then
         traceur_out(:,np)=-9999
       end if  !if good data
     end do !i=1,NPRF

     return
     end
