#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "handleLocalDefinitions.h"
#include "fortint.h"

typedef struct knownActions {
int count;
int * numbers;
action ** actions;
} knownActions;

knownActions known = {0,NULL,NULL};

int definitionIsDefined(struct knownActions * known, fortint number) {
int loop;

  for( loop = 0; loop < known->count; loop++ ) {
    if( known->numbers[loop] == number ) return loop;
  }

  known->count++;

  known->numbers = (int*) realloc(known->numbers,known->count*sizeof(int));
  if( known->numbers == NULL ) return -1;

  known->actions = (action**) realloc(known->actions,
                                      known->count*sizeof(action*));
  if( known->actions == NULL ) return -1;

  known->numbers[known->count-1] = number;
  known->actions[known->count-1] = createLocalDefinitionHandler(number);
  if( known->actions[known->count-1] == NULL ) return -1;

  return (known->count-1);
}

void decodeLocalDefinition(
  fortint localDefinitionNumber,
  fortint* packedValues,
  fortint* unpackedValues,
  fortint* numberOfUnpackedIntegers,
  fortint* numberOfPackedBytes) {
int listPosition;
unsigned char* packedValuesBytes = (unsigned char*) packedValues;

  listPosition = definitionIsDefined(&known,localDefinitionNumber);
  if( listPosition == -1 ) {
    *numberOfPackedBytes = 0;
    return;
  }

  decodeLocalDefinitionValues(known.actions[listPosition],
                              packedValuesBytes,unpackedValues,
                              numberOfUnpackedIntegers,
                              numberOfPackedBytes);
  return;
}

void dldefs(
  fortint* localDefinitionNumber,
  fortint* packedValues,
  fortint* unpackedValues,
  fortint* numberOfUnpackedIntegers,
  fortint* numberOfPackedBytes) {

  decodeLocalDefinition(*localDefinitionNumber,packedValues,unpackedValues,
                        numberOfUnpackedIntegers,numberOfPackedBytes);
  return;
}

fortint dldefs_(
  fortint* localDefinitionNumber,
  fortint* packedValues,
  fortint* unpackedValues,
  fortint* numberOfUnpackedIntegers,
  fortint* numberOfPackedBytes) {

  decodeLocalDefinition(*localDefinitionNumber,packedValues,unpackedValues,
                        numberOfUnpackedIntegers,numberOfPackedBytes);
  return;
}

void encodeLocalDefinition(
  fortint localDefinitionNumber,
  fortint* unpackedValues,
  fortint* packedValues,
  fortint* numberOfUnpackedIntegers,
  fortint* numberOfPackedBytes) {
int listPosition;
unsigned char* packedValuesBytes = (unsigned char*) packedValues;

  listPosition = definitionIsDefined(&known,localDefinitionNumber);
  if( listPosition == -1 ) {
    *numberOfPackedBytes = 0;
    return;
  }

  encodeLocalDefinitionValues(known.actions[listPosition],
                              unpackedValues,packedValuesBytes,
                              numberOfUnpackedIntegers,
                              numberOfPackedBytes);
  return;
}

fortint eldefs(
  fortint* localDefinitionNumber,
  fortint* unpackedValues,
  fortint* packedValues,
  fortint* numberOfUnpackedIntegers,
  fortint* numberOfPackedBytes) {

  encodeLocalDefinition(*localDefinitionNumber,unpackedValues,packedValues,
                       numberOfUnpackedIntegers,numberOfPackedBytes);
}

fortint eldefs_(
  fortint* localDefinitionNumber,
  fortint* unpackedValues,
  fortint* packedValues,
  fortint* numberOfUnpackedIntegers,
  fortint* numberOfPackedBytes) {

  encodeLocalDefinition(*localDefinitionNumber,unpackedValues,packedValues,
                       numberOfUnpackedIntegers,numberOfPackedBytes);
}

void insertSection1Length(fortint* section1, fortint* length) {
unsigned char* psection1 = (unsigned char*) section1;
unsigned char section1Length[3] = {'\0','\0','\0'};
fortint Length = *length;

  section1Length[0] = (Length & 0xff0000) >> 16;
  section1Length[1] = (Length & 0xff00) >> 8;
  section1Length[2] = (Length & 0xff);
  memcpy((psection1+8),section1Length,3);
  return;
}

void isec1l_(fortint* section1, fortint* length) {
  insertSection1Length(section1,length);
  return;
}

void isec1l(fortint* section1, fortint* length) {
  insertSection1Length(section1,length);
  return;
}

fortint ldefnum(fortint* centre, fortint* number) {
int shift = (sizeof(fortint)-1)*8;
#ifdef LITTLE_ENDIAN
  return ((*centre*1000) + (*number & 0xff));
#else
  return ((*centre*1000) + ((*number>>shift) & 0xff));
#endif
}

fortint ldefnum_(fortint* centre, fortint* number) {
  return ldefnum(centre,number);
}

void loadPrintLine(
  char* printLine,
  int printLineLength,
  char* contents,
  char* code,
  fortint* ksec1Value) {
int loop, printLength;
char value[9];
char p;
fortint number;

  for( loop = 0; loop < printLineLength; loop++) printLine[loop] = ' ';
  printLength = strlen(contents);
  if( printLength > (printLineLength-10) ) printLength = (printLineLength-10);
  strncpy((printLine+1),contents,printLength);

  if( strcmp(code,"A4") == 0 ) {
    memcpy(value,ksec1Value,4);
#ifdef LITTLE_ENDIAN
    swap4_(value);
#endif
    value[4] = '\0';
    sprintf((printLine+37),"      %s",value);
  }

  else if( strcmp(code,"BYTES") == 0 ) {
    sprintf(value,"%0x",*ksec1Value,8);
    if( strlen(value) < 8 ) {
      int missing = 8 - strlen(value);
      for( loop = 7; loop >= missing; loop-- ) value[loop] = value[loop-missing];
      for( loop = 0; loop < missing; loop++ ) value[loop] = '0';
    }
#ifdef LITTLE_ENDIAN
    p = value[0];
    value[0] = value[6];
    value[6] = p;
    p = value[1];
    value[1] = value[7];
    value[7] = p;
    p = value[2];
    value[2] = value[4];
    value[4] = p;
    p = value[3];
    value[3] = value[5];
    value[5] = p;
#endif
    value[8] = '\0';
    sprintf((printLine+37),"  %s",value);
  }

  else
    sprintf((printLine+37)," %9d",*ksec1Value);

  return;
}

void displayUnpackedSection1Values(
  fortint fileNumber,
  fortint* unpackedSection1Values) {
FILE * out;
char fileName[] = "fort.nn";
fortint localDefinitionNumber, listPosition;
action* a;
int valueToPrint = 41;
int expverFound = 0;
int printLength, loop, printableValue = 0;
int loopCount, listCount, padCount, byteCount;
char* loopName, *byteName;
#define LINELENGTH 46
char printLine[LINELENGTH] = "                                        ";

  if( (fileNumber < 1) || (fileNumber > 99) ) return;

  if( fileNumber == 6 ) {
    out = stdout;
    setbuf(out,NULL);
  }
  else {
    if( fileNumber < 10 ) 
      sprintf((fileName+5),"%1d",fileNumber);
    else
      sprintf((fileName+5),"%2d",fileNumber);
    out = fopen(fileName,"w");
  }
  if( out == NULL ) return;

  localDefinitionNumber =
    unpackedSection1Values[1]*1000 + unpackedSection1Values[36];
  listPosition = definitionIsDefined(&known,localDefinitionNumber);
  if( listPosition == -1 )
    return;
  else
    a = known.actions[listPosition];

  while(a) {
    if( expverFound ) {
/*
//    Abandon printing on following:
*/
      if( (strcmp((a->code),"IF_EQ") == 0) ||
          (strcmp((a->code),"IF_NEQ") == 0) ||
          (strcmp((a->code),"ENDIF") == 0) ||
          (strcmp((a->code),"PADTO") == 0) ||
          (strcmp((a->code),"SP_TO") == 0) ||
          (strcmp((a->code),"PADMULT") == 0) ) return;
/*
//    Avoid straightforward printing of following:
*/
      printableValue = ( (strcmp((a->ksec1),"n/a") != 0) &&
                         (strncmp((a->code),"PAD",3) != 0) &&
                         (strncmp((a->code),"LP_I",4) != 0) &&
                         (strcmp((a->code),"LIST") != 0) &&
                         (strcmp((a->code),"BYTES") != 0) &&
                         (strcmp((a->code),"F1") != 0) );
      if( printableValue ) {
        loadPrintLine(printLine,LINELENGTH,
                      (char*)(a->description),(char*)(a->code),
                      &unpackedSection1Values[valueToPrint]);
        fprintf(out,"%s\n",printLine);
      }
/*
//    Print loops:
*/
      if( strncmp((a->code),"LP_I",4) == 0 ) {
        loopCount = a->reference->value;
        loopName = strdup(a->description);
        for( loop = 0; loop < loopCount; loop++ ) {
          loadPrintLine(printLine,LINELENGTH,
                        loopName,(char*)(a->code),
                        &unpackedSection1Values[valueToPrint]);
          fprintf(out,"%s\n",printLine);
          valueToPrint++;
        }
        free(loopName);
      }
/*
//    Print bytes:
*/
      if( strcmp((a->code),"BYTES") == 0 ) {
        byteCount = a->reference->value;
        byteName = strdup(a->description);
        for( loop = 0; loop < byteCount/4; loop++ ) {
          loadPrintLine(printLine,LINELENGTH,
                        byteName,"BYTES",
                        &unpackedSection1Values[valueToPrint]);
          fprintf(out,"%s\n",printLine);
          valueToPrint++;
        }
        free(byteName);
      }
/*
//    Skip padding and only move the count if ksec1 is affected:
*/
      if( strncmp((a->code),"PAD",3) == 0 ) {
        if( (! stringIsNotANumber(a->count)) &&
            (strcmp((a->ksec1),"n/a") != 0) ) {
          padCount = atoi(a->count);
          valueToPrint += padCount;
        }
      }
/*
//    Print lists:
*/
      if( strcmp((a->code),"LIST") == 0 ) {
        char** listName = NULL;
        char** listCode = NULL;
        action* listPointer = a->next;
        int separateItems = 0, nextItem = 0;

        listCount = a->reference->value;
        listName = (char**) malloc(sizeof(char*));
        while( strcmp((listPointer->code),"ENDLIST") != 0 ) {
          separateItems++;
          listName = (char**) realloc(listName,separateItems*sizeof(char*));
          listName[separateItems-1] = strdup(listPointer->description);
          listCode = (char**) realloc(listCode,separateItems*sizeof(char*));
          listCode[separateItems-1] = strdup(listPointer->code);
          listPointer = listPointer->next;
        }

        nextItem = 0;
        for( loop = 0; loop < (listCount*separateItems); loop++ ) {
          loadPrintLine(printLine,LINELENGTH,
                      listName[nextItem],listCode[nextItem],
                      &unpackedSection1Values[valueToPrint]);
          fprintf(out,"%s\n",printLine);
          valueToPrint++;
          nextItem++;
          if( nextItem == separateItems ) nextItem = 0;
        }
        for( loop = 0; loop < separateItems; loop++ ) {
          free(listName[loop]);
          free(listCode[loop]);
        }
        free(listName);
        free(listCode);
/*
//      Skip to ENDLIST (which will not be displayed)
*/
        a = listPointer;
      }
    }
    if( strcmp("experimentVersionNumber",a->description) == 0 ) expverFound = 1;
    if( printableValue ) valueToPrint++;
    a = a->next;
  }

  if( fileNumber != 6 ) fclose(out);

  return;
}

void ldefprt(fortint* fileNumber, fortint* unpackedSection1Values) {
  displayUnpackedSection1Values(*fileNumber,unpackedSection1Values);
  return;
}

void ldefprt_(fortint* fileNumber, fortint* unpackedSection1Values) {
  displayUnpackedSection1Values(*fileNumber,unpackedSection1Values);
  return;
}
