SUBROUTINE BROADCCHAR (CCHARAR,KINTDIM,KPEOWNER,KTAG)

!     *BROADCCHAR*  Broadcast a Character array.

!     Interface.
!     ----------
!        *CALL* *BROADCCHAR (CCHARAR,KINTDIM,KPEOWNER,KTAG)

!        Explicit arguments : 
!        -------------------- 
!        CCHARAR  : input array
!        KINTDIM  : dimension of CCHARAR
!        KPEOWNER : PE that owns the array that is being distributed
!        KTAG     : Message Passing Tag

!        Implicit arguments :
!        --------------------

!     Author.
!     -------
!        Lars Isaksen *ECMWF*

!     Modifications.
!     --------------
!        Original: 96-10-01 
!        Modified: 00-09-01 by D.Dent : MPE to MPL conversion
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE MPL_MODULE

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KINTDIM 
CHARACTER*(KINTDIM)              :: CCHARAR ! UNDETERMINED INTENT
INTEGER(KIND=JPIM)               :: KPEOWNER ! UNDETERMINED INTENT
INTEGER(KIND=JPIM),INTENT(IN)    :: KTAG 
INTEGER(KIND=JPIM) ::    ITAG
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('BROADCCHAR',0,ZHOOK_HANDLE)
ITAG=KTAG
CALL MPL_BROADCAST(CCHARAR(1:KINTDIM),KROOT=KPEOWNER,KTAG=ITAG, &
 & CDSTRING='BROADCCHAR:')  

IF (LHOOK) CALL DR_HOOK('BROADCCHAR',1,ZHOOK_HANDLE)
END SUBROUTINE BROADCCHAR
