SUBROUTINE BROADCINT(KINTAR,KINTDIM,KPEOWNER,KTAG)

!     *BROADCINT*  Broadcast an integer array.

!     Interface.
!     ----------
!        *CALL* *BROADCINT(KINTAR,KINTDIM,KPEOWNER,KTAG)

!        Explicit arguments : 
!        -------------------- 
!        KINTAR   : input array
!        KINTDIM  : dimension of KINTAR
!        KPEOWNER : PE that owns the array that is being distributed
!        KTAG     : Message Passing Tag

!        Implicit arguments :
!        --------------------

!     Author.
!     -------
!        Lars Isaksen *ECMWF*

!     Modifications.
!     --------------
!        Original: 96-10-01 
!        Modified: 00-09-01 by D.Dent : MPE to MPL conversion
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!     ------------------------------------------------------------------

USE PARKIND1  ,ONLY : JPIM     ,JPRB
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK

USE MPL_MODULE

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KINTDIM 
INTEGER(KIND=JPIM)               :: KINTAR(KINTDIM) ! UNDETERMINED INTENT
INTEGER(KIND=JPIM)               :: KPEOWNER ! UNDETERMINED INTENT
INTEGER(KIND=JPIM),INTENT(IN)    :: KTAG 
INTEGER(KIND=JPIM) ::    ITAG
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('BROADCINT',0,ZHOOK_HANDLE)
ITAG=KTAG
CALL GSTATS(525,0)
CALL MPL_BROADCAST(KINTAR(1:KINTDIM),KROOT=KPEOWNER,KTAG=ITAG, &
 & CDSTRING='BROADCINT:')  
CALL GSTATS(525,1)

IF (LHOOK) CALL DR_HOOK('BROADCINT',1,ZHOOK_HANDLE)
END SUBROUTINE BROADCINT
