*COMDECK PARAM
C
C*    *PARAMETERS* CONTROLLING ARRAY SIZES.
C
C       ----------------------------------------------------------------
C
      PARAMETER(
     I JPM=213,  JPN=213,  JPK=213,  JPGL=320, JPNLON=640,
     I JPNLEV=33,          JPSLEV=4,
     I JPNTASK=14,         JPTASKS=18,         JPLOCKS=50,
     I JPLTMT= JPTASKS,    JPEVENT=JPGL,
     I JPNUMW=240, JPNUMP=240,
     I JPTABLE=1024,     JPNFNTE=10,      JPNFNTN=44, JPNFNEC=JPNFNTE*8,
     I JPMAXB=JPTASKS*15, JPMAXPB=32,
     I JPLPP2= 1200,       JPVPP2= 3,
     I JPG1FLD=3,    JPG2FLD=4,
     I JPG3FLD=51,   JPG3XF=19,    JPG3CMP=17,
     I JPWQTYPE=10,
     I JPGUTYPE=3,    JPGSTYPE=80,   JPFCTYPE=40,   JPLCTYPE=20,
     I JPSLTYPE=3,    JPDFTYPE=3,    JPRDTYPE=70,   JPSPTYPE=30,
     I JPDITYPE=60,   JPMDTYPE=50,
     I JPGTASK =11,   JPLTASK =20,   JPFTASK =40,
     I JPWFTAB =12,
     I JPMP1=JPM+1,        JPNP1=JPN+1,       JPKP1=JPK+1,
     I JP2MP1=JPMP1*2,     JP4MP1=JPMP1*4,
     I JPED=JPN/2+1,       JPOD=JPNP1/2,
     I IPSP0=JPM+JPN-JPK,  IPSP1=JPNP1*JPMP1, IPSP2=IPSP0*(IPSP0+1)/2,
     I JPSP=IPSP1-IPSP2,   JP2SP=2*JPSP,
     I JPHGL=JPGL/2,       JPNLP2=JPNLON+2,
     I JPNLVP1=JPNLEV+1,   JPNVCLV=2*JPNLVP1)
#ifdef DOC
C
C*    *PARAMETERS* CONTROLLING ARRAY SIZES.
C
C          M.JARRAUD     E.C.M.W.F.     26/10/81.
C
C      NAME     TYPE      PURPOSE
C      ----     ----      -------
C
C     *IP---*   INTEGER   USED FOR INTERMEDIATE COMPUTATIONS OF
C                         MAIN PARAMETERS.
C     *JPM*     INTEGER   MAX ZONAL WAVE NUMBER.
C     *JPN*     INTEGER   MAX MERIDIONAL WAVE NUMBER FOR M=0.
C     *JPK*     INTEGER   MAX MERIDIONAL WAVE NUMBER.
C     *JPGL*    INTEGER   NUMBER OF GAUSSIAN LATITUDES.
C     *JPLPP2*  INTEGER  LENGTH OF /COMPP2/ (*POSTIN* DATA)
C     *JPVPP2*  INTEGER  NUMBER OF COPIES OF /COMPP2/ HELD.
C     *JPMAXB*  INTEGER  MAXIMUM NUMBER OF MODEL I/O TABLES IN *COMBUF*
C     *JPMAXPB* INTEGER  MAXIMUM NUMBER OF PP I/O TABLES IN *COMPBF*
C     *JPNLON*  INTEGER   MAX NUMBER OF POINTS ON EACH LATITUDE LINE.
C     *JPNLEV*  INTEGER   NUMBER OF VERTICAL LEVELS.
C     *JPSLEV*  INTEGER   NUMBER OF LEVELS IN SOIL.
C     *JPNUMP*  INTEGER  MAXIMUM NUMBER OF POSTPROCESSING POINTS
C     *JPNUMW*  INTEGER  MAXIMUM NUMBER OF WRITEUP POINTS
C     *JPTASKS* INTEGER   MAXIMUM NUMBER OF TASKS THAT MAY CO-EXIST.
C     *JPNTASK* INTEGER  DEFAULT NUMBER OF TASKS IF *LMULTSK=TRUE*
C     *JPLOCKS* INTEGER   MAXIMUM NUMBER OF LOCKS AVAILABLE.
C     *JPEVENT* INTEGER   MAXIMUM NUMBER OF EVENTS AVAILABLE.
C     *JPLTMT*  INTEGER   NO OF SUBDIVISIONS OF WORK WITHIN *LTD*
C                         AND *LTDU* WHEN *NTASKS* GT 2
C     *JPTABLE* INTEGER  TABLE SIZE FOR MULTI-TASKING TRACE
C     *JPG1FLD* INTEGER   NUMBER OF FIELDS IN STANDARD *G1 FILE
C     *JPG2FLD* INTEGER   NUMBER OF FIELDS IN STANDARD *G2 FILE
C     *JPG3FLD* INTEGER   NO OF FIELDS IN STANDARD *G3 FILE
C     *JPG3XF*  INTEGER   MAXIMUM NO OF ADDITIONAL *G3 FIELDS ALLOWED
C     *JPG3CMP* INTEGER   NUMBER OF FIELDS IN COMPRESSED G3 FILE
C     *JPED*    INTEGER   NUMBER OF EVEN DIAGONALS IN THE TRUNCATION.
C     *JPOD*    INTEGER   NUMBER OF ODD  DIAGONALS IN THE TRUNCATION.
C     *JPSP*    INTEGER   NUMBER OF SPECTRAL COEFFICIENTS.
C     *JPGUTYPE INTEGER  MM CODE FOR UPPER-AIR GRID POINT  DATA
C     *JPGSTYPE INTEGER  MM CODE FOR SURFACE   GRID POINT  DATA
C     *JPFCTYPE INTEGER  MM CODE FOR FOURIER               DATA
C     *JPLCTYPE INTEGER  MM CODE FOR LEGENDRE              DATA
C     *JPSLTYPE INTEGER  MM CODE FOR SEMI-LAGRANGIAN       DATA
C     *JPDFTYPE INTEGER  MM CODE FOR DIFFERENCE GRID POINT DATA
C     *JPRDTYPE INTEGER  MM CODE FOR RADIATION             DATA
C     *JPSPTYPE INTEGER  MM CODE FOR SPECTRAL              DATA
C     *JPDITYPE INTEGER  MM CODE FOR DIAGNOSTIC            DATA
C     *JPMDTYPE INTEGER  MM CODE FOR MASK DIAGNOSTIC       DATA
C     *JPGTASK  INTEGER  MM CODE FOR TASK DEPENDANT GRID-POINT DATA
C     *JPFTASK  INTEGER  MM CODE FOR TASK DEPENDANT FOURIER    DATA
C     *JPLTASK  INTEGER  MM CODE FOR TASK DEPENDANT LEGENDRE   DATA
C
#endif
